//----------------------------------------------------------------+
// sleep function added
#define        SIGNAL_NONE             0
#define        SIGNAL_BUY              1
#define        SIGNAL_SELL             2
#define        SIGNAL_CLOSEBUY         3
#define        SIGNAL_CLOSESELL        4

#property copyright                      "ChiStabo 2009"

extern string  Remark1                 = "== Main Settings ==";
extern int     MagicNo                 = 373737;
extern bool    SignalsOnly             = False;
extern bool    Alerts                  = False;
extern bool    SignalMail              = False;
extern bool    PlaySounds              = False;
extern bool    EachTickMode            = True;
extern bool    CloseOnOppositeSignal   = false;
extern string  Remark2                 = "== Money Management ==";
extern double  Lots                    = 0.01;
extern bool    MoneyManagement         = False;
extern int     Risk                    = 1;
extern int     Slippage                = 50;
extern bool    UseStopLoss             = True;
extern int     StopLoss                = 1500;
extern bool    UseTakeProfit           = true;
extern int     TakeProfit              = 2100;
extern bool    UseTrailingStop         = true;
extern int     TrailingStop            = 1200;
extern bool    MoveStopOnce            = true;
extern int     MoveStopWhenPrice       = 410;
extern int     MoveStopTo              = 210;
extern string  Remark3                 = "== Trading Hours are Broker time ==";
extern int     StartTrading            = 0,
               StopTrading             = 24;
int            BarCount;
int            Current;
bool           TickCheck               = False;
int            LookBack                = 2;
datetime       CheckEntryTime;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() 
   {
   BarCount = Bars;
   if (EachTickMode) Current = 0; else Current = 1;
   return(0);
   }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
   {
   return(0);
   }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
   {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
//----- Money Management sequence
   if (MoneyManagement)
      {
      if (Risk < 1 || Risk > 100)
         {
         Comment ("Invalid Risk");
         return(0);
         }
      else
         {
         Lots = MathFloor ((AccountFreeMargin() * AccountLeverage() * Risk * Point * 100) / (Ask *
         MarketInfo (Symbol(), MODE_LOTSIZE) * MarketInfo (Symbol(), MODE_MINLOT))) * MarketInfo (Symbol(), MODE_MINLOT);
         } 
      }
//+------------------------------------------------------------------+
//| Variable Begin                                                   |
//+------------------------------------------------------------------+
      double   upfractal = GetFractal (MODE_UPPER),
               dnfractal = GetFractal (MODE_LOWER);

//+------------------------------------------------------------------+
//| Variable End                                                     |
//+------------------------------------------------------------------+
   if (CheckEntryTime == iTime (NULL, 0, 0)) return (0);
   else CheckEntryTime = iTime (NULL, 0, 0);
//----- Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++)
      {
      OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL &&  OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNo)
         {
         IsTrade = True;
         if (OrderType() == OP_BUY)
            {         
//----- Close
//+------------------------------------------------------------------+
//| Signal Begin(Exit Buy)                                           |
//+------------------------------------------------------------------+
            if (CloseOnOppositeSignal && upfractal != 0 && Hour() >= StartTrading && Hour() < StopTrading)
            Order = SIGNAL_CLOSEBUY;
//+------------------------------------------------------------------+
//| Signal End(Exit Buy)                                             |
//+------------------------------------------------------------------+
            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))))
               {
               OrderClose (OrderTicket(), OrderLots(), Bid, Slippage, Blue);
               if (SignalMail) SendMail ("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr (Bid, Digits) + " PPC Naked Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
               }
//----- MoveOnce
            if (MoveStopOnce && MoveStopWhenPrice > 0)
               {
               if (Bid - OrderOpenPrice() >= Point * MoveStopWhenPrice)
                  {
                  if (OrderStopLoss() < OrderOpenPrice() + Point * MoveStopTo)
                     {
                     OrderModify (OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + Point * MoveStopTo, OrderTakeProfit(), 0, White);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                     }
                  }
               }
//----- Trailing stop
            if (UseTrailingStop && TrailingStop > 0)
               {
               if (Bid - OrderOpenPrice() > Point * TrailingStop)
                  {
                  if (OrderStopLoss() < Bid - Point * TrailingStop)
                     {
                     OrderModify (OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, White);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                     }
                  }
               }
            }
         if (OrderType() == OP_SELL)
            {
//----- Close
//+------------------------------------------------------------------+
//| Signal Begin(Exit Sell)                                          |
//+------------------------------------------------------------------+
            if (CloseOnOppositeSignal && dnfractal != 0 && Hour() >= StartTrading && Hour() < StopTrading)
            Order = SIGNAL_CLOSESELL;
//+------------------------------------------------------------------+
//| Signal End(Exit Sell)                                            |
//+------------------------------------------------------------------+
            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))))
               {
               OrderClose (OrderTicket(), OrderLots(), Ask, Slippage, Blue);
               if (SignalMail) SendMail ("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr (Ask, Digits) + " PPC Naked Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
               }
//----- MoveOnce
            if (MoveStopOnce && MoveStopWhenPrice > 0)
               {
               if (OrderOpenPrice() - Ask >= Point * MoveStopWhenPrice)
                  {
                  if (OrderStopLoss() > OrderOpenPrice() - Point * MoveStopTo)
                     {
                     OrderModify (OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - Point * MoveStopTo, OrderTakeProfit(), 0, White);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                     }
                  }
               }
//----- Trailing stop
            if (UseTrailingStop && TrailingStop > 0)
               {
               if (OrderOpenPrice() - Ask > Point * TrailingStop)
                  {
                  if (OrderStopLoss() > Ask + Point * TrailingStop)
                     {
                     OrderModify (OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, White);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                     }
                  }
               }
            }
         }
      }
//+------------------------------------------------------------------+
//| Signal Begin(Entry)                                              |
//+------------------------------------------------------------------+
//----- BUY
      if (dnfractal != 0 && Hour() >= StartTrading && Hour() < StopTrading)
      Order = SIGNAL_BUY;
//----- SELL
      if (upfractal != 0 && Hour() >= StartTrading && Hour() < StopTrading)
      Order = SIGNAL_SELL;

//+------------------------------------------------------------------+
//| Signal End                                                       |
//+------------------------------------------------------------------+
//----- Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))))
      {
      if (SignalsOnly)
         {
         if (SignalMail) SendMail ("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr (Ask, Digits) + " PPC Naked Buy Signal");
         if (Alerts) Alert ("[" + Symbol() + "] " + DoubleToStr (Ask, Digits) + " PPC Naked Buy Signal");
         if (PlaySounds) PlaySound ("alert.wav");
         }
      
      if (!IsTrade && !SignalsOnly)
         {
//----- Check free margin
         if (AccountFreeMargin() < (1000 * Lots))
            {
            Print ("Not enough money. Free Margin = ", AccountFreeMargin());
            return(0);
            }
         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point;          else StopLossLevel   = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point;    else TakeProfitLevel = 0.0;

         Ticket = OrderSend (Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "PPC Naked Buy " + Symbol(), MagicNo, 0, Lime);
         if (Ticket > 0)
            {
            if (OrderSelect (Ticket, SELECT_BY_TICKET, MODE_TRADES))
               {
               Print ("PPC Naked BUY opened: ", OrderOpenPrice());
               if (SignalMail) SendMail ("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr (Ask, Digits) + " PPC Naked Buy Signal");
               if (Alerts) Alert ("[" + Symbol() + "] " + DoubleToStr (Ask, Digits) + " PPC Naked Buy Signal");
               if (PlaySounds) PlaySound ("alert.wav");
   			   }
			   else
			      {
   				Print ("Error opening BUY: ", GetLastError());
   			   }
            }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
         }
      }
//----- Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))))
      {
      if (SignalsOnly)
         {
         if (SignalMail) SendMail ("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr (Bid, Digits) + " PPC Naked Sell Signal");
         if (Alerts) Alert ("[" + Symbol() + "] " + DoubleToStr (Bid, Digits) + " PPC Naked Sell Signal");
         if (PlaySounds) PlaySound ("alert.wav");
         }
      if (!IsTrade && !SignalsOnly)
         {
//----- Check free margin
         if (AccountFreeMargin() < (1000 * Lots))
            {
            Print ("Not enough money. Free Margin = ", AccountFreeMargin());
            return(0);
            }
         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point;          else StopLossLevel   = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point;    else TakeProfitLevel = 0.0;
         
         Ticket = OrderSend (Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "PPC Naked Sell " + Symbol(), MagicNo, 0, Red);
         if (Ticket > 0)
            {
            if (OrderSelect (Ticket, SELECT_BY_TICKET, MODE_TRADES))
               {
				  Print ("PPC Naked SELL opened: ", OrderOpenPrice());
               if (SignalMail) SendMail ("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr (Bid, Digits) + " PPC Naked Sell Signal");
               if (Alerts) Alert ("[" + Symbol() + "] " + DoubleToStr (Bid, Digits) + " PPC Naked Sell Signal");
               if (PlaySounds) PlaySound ("alert.wav");
			      }
			   else
   			   {
               Print ("Error opening SELL: ", GetLastError());
			      }
            }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
         }
      }
   if (!EachTickMode) BarCount = Bars;
//=================================================
   if (IsTradeContextBusy()) Sleep (5000); return;
//=================================================
   return(0);
   }
//----- GET FRACTAL FUNCTION
double GetFractal(int mode)
   {
   double tempup = 0, tempdn = 0, fup = 0, fdn = 0;
   tempup = iFractals (Symbol(), 0, MODE_UPPER, LookBack);
   tempdn = iFractals (Symbol(), 0, MODE_LOWER, LookBack);
   if(tempup != 0) fup = tempup;
   if(tempdn != 0) fdn = tempdn;

   if (fup != 0 && fdn == 0 && mode == MODE_UPPER) return (fup);
   if (fdn != 0 && fup == 0 && mode == MODE_LOWER) return (fdn);
   return(0);
   }